      subroutine coll1(iprint,isotop,imol)
c--------------------------------------------------------------------
c    Reads in the collision rates from the disk file and fits
c    splines to interpolate in temperature.
c--------------------------------------------------------------------
      INCLUDE 'rad_size.h'
      INCLUDE 'radiat.h'
      INCLUDE 'crates.h'
      character line*120,line2*80,isotop*10
      real a1(MAXTEMPS),f1(MAXTEMPS),epsln
      integer iprint,imol
      integer i,j,k,jini,jfin,ji,ki,k1i,jf,kf,k1f
      integer jmaxc(MAXKS),kmaxc,idini,idfin,ncoll
      logical more
      data more / .true./
c--------------------------------------------------------------------
c    read comments from beginning of file and print out 
c-------------------------------------------------------------------- 
      call LogWrite('     Comments in collision rates file follow:',
     1			more)
      do 50 i=1,20
        read(12,'(a)') line
        if(line(1:5) .eq. 'START') go to 55
        line2(6:80) = line(1:75)
        line2(1:5) = '     '
        call LogWrite(line2,more)
  50  continue
  55  continue
c----------------------------------------------------------------------
c    Read from disk the number of temperatures and number
c    of k levels for which rates exist, then read the K values for each 
c    ladder, the maximum numbers of levels within each K ladder, and 
c    temperature values 
c----------------------------------------------------------------------
      read(12,'(14x,i2,19x,i2)') nt,kmaxc
      read(12,'(18(i2,1x))') (kval(i),i=1,kmaxc),(jmaxc(i),i=1,kmaxc)
      read(12,'(3(5x,10(1x,f6.1),/))') (temp(i),i=1,nt)
      if(iprint.ge.3) then
         write(line,'('' temps: '',10(f7.3,2x))') (temp(i),i=1,nt)
         call LogWrite(line,more)
      endif
c----------------------------------------------------------------------
c     Choose kmax and jmax values to be the minumim of those selected
c     by the user or those available in the collision file
c----------------------------------------------------------------------
      if(kmax .gt. 0) then
	 kmax = min0(kmax,kmaxc)
      else
	 kmax = kmaxc
      endif
      do 60 i=1,kmax
	 if(jmax(i) .gt. 0) then
	    jmax(i) = min0(jmax(i),jmaxc(i))
	 else
	    jmax(i) = jmaxc(i)
	 endif
  60  continue
      nlev  = 0
      ncoll = 0
      do 70 i=1,kmax
	 nlev  = nlev  + jmax(i)
	 ncoll = ncoll + jmax(i)
  70  continue
c----------------------------------------------------------------------
c     call rad subroutine to calculate the radiative stuff for levels
c     of interest. This also set the array order of the levels
c----------------------------------------------------------------------
      if(imol .eq. 1) call radlin(iprint)
      if(imol .eq. -1) call radasy(iprint,isotop)
      if(imol .eq. -2) call radsym(iprint,isotop)
c----------------------------------------------------------------------
c     Read in the collision rates and place each rate in the proper
c     place to correspond to its levels
c----------------------------------------------------------------------
      do 100 i=1,ncoll
      do 100,j=1,ncoll
         read(12,'(3(i2,1x),3(1x,i2))') ji,ki,k1i,jf,kf,k1f
         idini   = -1
	 idfin   = -1
	 jini = 10000*ji+100*ki+k1i
	 jfin = 10000*jf+100*kf+k1f
	 do 75 k=1,nlev
	    if(jini .eq. jklev(k)) idini = k
	    if(jfin .eq. jklev(k)) idfin = k
   75	 continue
         if( idini .gt. 0 .AND. idfin .gt. 0) then
            read(12,'(5(1x,8(f8.2,1x),/))') (f2(idini,idfin,k),k=1,nt)
	 else
	    read(12,'(5(1x,8(f8.2,1x),/))')  (a1(k),k=1,nt)
            write(line,'('' No Level '',3(i2,1x),'' or '',3(i2,1x))')
     1			ji,ki,k1i,jf,kf,k1f
	    if(iprint .ge. 1) call LogWrite(line,more)
	 endif
         if(iprint.ge.3) then
	   if(nt .le. 8) then
	     write(line,'(6(i2,1x),2x,8(f9.3,1x))') 
     1               ji,ki,k1i,jf,kf,k1f,(f2(idini,idfin,k),k=1,nt)
	     call LogWrite(line,more)
           else
	     write(line,'(6(i2,1x),2x,8(f9.3,1x))')                  
     1               ji,ki,k1i,jf,kf,k1f,(f2(idini,idfin,k),k=1,8)
	     call LogWrite(line,more)
             write(line,'(23x,8(f9.3,1x))') (f2(idini,idfin,k),k=9,nt)
	     call LogWrite(line,more)
	   endif 
         endif
  100 continue
c----------------------------------------------------------------------
c    Now fit the splines to the data.
c----------------------------------------------------------------------
      epsln=1.0e-5
      do 300 jini=1,nlev
         do 250 jfin=1,nlev
            if(ener(jini) .lt. ener(jfin)) go to 250
            do 150 i=1,nt
               f1(i)=f2(jini,jfin,i)
  150       continue
            call splnc(nt,temp,f1,epsln,a1)
            do 200 i=1,nt
               a2(jini,jfin,i)=a1(i)
  200       continue
  250    continue
  300 continue
      return
      end
c********************************************************************
c*************************** END OF COLL1 ***************************
c********************************************************************
