      subroutine coll2(tt)
c--------------------------------------------------------------------
c    Interpolates the collision rates from the spline fit done
c    in the coll1 subroutine.
c--------------------------------------------------------------------
      INCLUDE 'rad_size.h'
      INCLUDE 'radiat.h'
      INCLUDE 'crates.h'
      real a1(50),b1(50),d(50),f1(50),tdif,tt
      integer ji,jf,i
c
      d(1)=tt
      if(tt .lt. temp(1)) d(1)=temp(1)
      if(tt .gt. temp(nt)) d(1)=temp(nt)
c--------------------------------------------------------------------
c    Use the spline fit to interpolates the value for the downward
c    collision rates.
c--------------------------------------------------------------------
      do 10 ji=1,nlev
         do 20 jf=1,nlev
            if(ener(ji) .lt. ener(jf)) go to 20
            do 30 i=1,nt
               a1(i)=a2(ji,jf,i)
               f1(i)=f2(ji,jf,i)
   30       continue
            call spln(nt,1,temp,f1,d,b1,a1)
            col(ji,jf)=1.0e-10*b1(1)
   20    continue
   10 continue
c--------------------------------------------------------------------
c    Calculate the upward rates from statistical equilibrium.
c--------------------------------------------------------------------
      do 50 jf=1,nlev
      do 50 ji=1,nlev
         if(ener(ji).ge.ener(jf)) go to 50
         tdif=(ener(jf)-ener(ji))*ah/ak
	 if(tdif/tt .lt. 30.0) then
            col(ji,jf)=degen(jf)*col(jf,ji)*exp(-tdif/tt)/degen(ji)
	 else
	    col(ji,jf)=0.0
	 endif
   50 continue
c--------------------------------------------------------------------
      return
      end
c********************************************************************
c*************************** END OF COLL2 ***************************
c********************************************************************
