c+
      SUBROUTINE hisappn(tno,file,insert)
      INTEGER   tno
      CHARACTER file*(*)
      LOGICAL   insert
c
c   Append the history from a file to an open dataset. Optionally
c   history files can be appended in ``INSERT'' mode, i.e. a space
c   is inserted before each line is copied over. This is useful
c   where the datastream model was not linear, but information
c   from another dataset was inserted/used at this point.
c
c   Input:
c       tno        handle of the open dataset to append history to
c                  hisopen() must have been called.
c       file       filename of dataset to append history from
c       insert     insert space before each history line copied?
c
c--
      CHARACTER line*132
      INTEGER   fno, len1, iostat, i
      LOGICAL   eof, hdprsnt

c
c First open the 'file' from which to read history
c
      CALL hopen(fno, file, 'old', iostat)
      IF (iostat.NE.0) THEN
         line = 'File '//file(1:len1(file))//' does not exist'
         CALL bug('w',line)
         RETURN
      ENDIF
c
c If history item does not exist, no work has to be done
c
      IF (.not.hdprsnt(fno,'history')) THEN
         CALL hclose(fno)
         RETURN
      ENDIF
c
c Open the history file from 'file' ('fno')
c
      CALL hisopen(fno,'read')
c
c Read each line, and copy it over
c
      eof = .FALSE.
      DO WHILE(.NOT.eof)
         CALL hisread(fno,line,eof)
         IF (.NOT.eof) THEN
            IF(insert) THEN
               DO i=len1(line),1,-1
                  line(i+1:i+1) = line(i:i)
               ENDDO
               line(1:1) = ' '
            ENDIF
            CALL hiswrite(tno,line)
         ENDIF
      ENDDO
c
c Close all things we opened
c
      CALL hisclose(fno)
      CALL hclose(fno)

      END
