        subroutine molread(molcul,inam,imol) 
c--------------------------------------------------------------------
c    Identifies molecule and finds cross section file. 
c    The file is called unit 12.  
c    INPUT : molcul : character : name of molecule
C    OUTPUT: inam   : integer   : index of molecule name in nammol list
C                                 0 if the molecule is not known the program.
C            imol   : integer   : molecule type code; 1 = linear,
C                                 -1 = H2CO, -2 = ch3cn
c--------------------------------------------------------------------
        integer MAXMOL
        parameter (MAXMOL = 11)
        character nammol(MAXMOL)*10,molcul*10,line*80
        character namfil(MAXMOL)*10,catname*50,fullname*50
	character alph*26, caps*26
        integer itype(MAXMOL),i,ncat,inam,imol,j
        logical more
        data nammol/ 'HCOP ','HCN  ','CS   ','CO   ','HC3N ', 
     1    'OCS  ','SIO  ','OH2CO','PH2CO','OCH3CN','PCH3CN' / 
        data namfil/ 'hcop.dat  ','hcn.dat   ','cs.dat    ',
     1    'co.dat    ','hc3n.dat  ','ocs.dat','sio.dat   ',
     1    'oh2co.dat','ph2co.dat','och3cn.dat','pch3cn.dat' /
        data itype / 1,1,1,1,1,1,1,-1,-1,-2,-2 /
	data alph / 'abcdefghijklmnopqrstuvwxyz'/
        data caps / 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
        data more / .true. /
        external fullname
	do i=1,10
	   do j=1,26
	      if(molcul(i:i) .eq. alph(j:j)) molcul(i:i) = caps(j:j)
	   enddo
	enddo
        inam=0 
        do 100 i=1,MAXMOL
           if(molcul.eq.nammol(i)) inam=i 
  100 continue 
        if(inam.le.0) then 
           write(line,2001) molcul 
	   call LogWrite(line,more)
        else 
           catname = fullname('$RADCAT/')
           do 200 i=1,50
              if(catname(i:i) .ne. ' ') ncat = i
  200	   continue
           open(unit=12,file=catname(1:ncat)//'/'//namfil(inam),
     1				status='old') 
           write(line,2011) namfil(inam)
           call LogWrite(line,more)
           imol=itype(inam)
        end if 
 2001 format(2x,a10,' Does not match list of molecules') 
 2011 format('  COLLISION RATE FILE: ',a10)
        return 
        end
c********************************************************************
c************************* END OF MOLREAD ***************************
c********************************************************************
