      SUBROUTINE SOLV(STEQ,XN,NLEV,POPN) 
C
C   SOLVES THE STATISTICAL EQUILIBRIUM EQUATIONS BY MATRIX INVERSION
C
      INCLUDE 'rad_size.h'
      INTEGER NLEV,I,J
      DOUBLE PRECISION STEQ(MAXLEV,MAXLEV),XN(MAXLEV),POPN(MAXLEV)
      DOUBLE PRECISION R(MAXLEV),DEL(MAXLEV),EV(MAXLEV) 

      DO 10 I=1,NLEV 
         EV(I)=XN(I) 
         STEQ(NLEV,I)=1.0D0 
   10 CONTINUE 
      CALL VMULT(R,STEQ,EV,NLEV,NLEV,MAXLEV,MAXLEV) 
C
C   RESCALING TO AVOID UNDERFLOW DURING INVERSION
C
      DO 20 I=1,NLEV
      DO 20 J=1,NLEV
   20    STEQ(I,J) = 10.0D0 * STEQ(I,J)
      CALL INVERT(STEQ,NLEV,MAXLEV) 
      DO 30 I=1,NLEV
      DO 30 J=1,NLEV
   30    STEQ(I,J) = 10.0D0 * STEQ(I,J)
      DO 40 I=1,NLEV 
         R(I) = -R(I) 
   40 CONTINUE 
      R(NLEV) = R(NLEV) + 1.0D0
      CALL VMULT(DEL,STEQ,R,NLEV,NLEV,MAXLEV,MAXLEV) 
      DO 50 I=1,NLEV 
         POPN(I) = XN(I) + DEL(I) 
   50 CONTINUE 
      RETURN 
      END 
C********************************************************************
C***************************** END OF SOLV **************************
C********************************************************************
