      subroutine splnc(n,x,y,epsln,s2)
c--------------------------------------------------------------------
c    General remarks from original spline routine.
c    spln1 is third order spline function fitting routine written
c    by M. Macfarlane in december 1970.  a general interpolation,
c    quadrature routine.  There are n input points y(x) and m
c    interpolated points ss(t).  Epsln is the error of the fit, 
c    preselected actual value, not percent.  algorithm from  
c    mathematical methods for digital computers--vol2  edited by 
c    Ralston and Wilf routine separated into two parts by 
c    J. Woodman.
c
c    splnc - Calculates coefficients
c    spln - Performs interpolation
c--------------------------------------------------------------------
      real x(1),y(1),s2(1),epsln
      integer n
c
      integer itmax,i,n1,it
      real h,h2,dlsqy,omega,eta,b,c,w
c
      data itmax / 50 /
      epsln = abs(epsln)
      n1 = n-1
      do 52 i=2,n1
      h = x(i+1) - x(i)
      if (h.le.0.e0) go to 25
      h2 = x(i+1) - x(i-1)
      dlsqy=(((y(i+1)-y(i))/h)-(y(i)-y(i-1))/(x(i)-x(i-1)))/h2
   52 s2(i) = 2.*dlsqy
      s2(1) = 0.
      s2(n) = 0.
      omega = 1.0717968
      it = 0
    5 eta = 0.
      it = it+1
      if (it.gt.itmax) go to 20
      do 10 i=2,n1
      h = x(i+1) - x(i)
      h2 = x(i+1) - x(i-1)
      dlsqy=(((y(i+1)-y(i))/h)-(y(i)-y(i-1))/(x(i)-x(i-1)))/h2
      c = dlsqy*3.
      b = 0.5*(x(i)-x(i-1))/(x(i+1)-x(i-1))
      w = (c-b*s2(i-1)-(0.5-b)*s2(i+1)-s2(i))*omega
      if (abs(w)-eta) 10,10,9
    9 eta = abs(w)
   10 s2(i) = s2(i)+w
      if(eta-epsln) 14,5,5
   14 continue
      return
   20 write (*,950) it
      return
   25 write (*,951) x(1),x(n)
      stop2
  950 format (1x,'splnc failed to converge after',i5,'iterations')
  951 format (1x,'Input data to splnc does not increase as needed',
     1   2g10.3 )
      end
c********************************************************************
c***************************** END OF SPLNC *************************
c********************************************************************
