      SUBROUTINE TAUBETA(BET1,TAU)
C------------------------------------------------------
C     Calculates optical depth for the input escape
C     probability (BET1)
C------------------------------------------------------
      DOUBLE PRECISION BET1,B,DB,DBDT,TAU,TAU1,DT
      TAU1=1.0D0
      IF(BET1.LT.1.0E-6) BET1=1.0D-6
      IF(BET1.LT.0.10) THEN
         TAU=1.0D0/BET1
      ELSE
         IF(BET1.GT.0.97) THEN
            TAU=2.0D0*(1.0D0-BET1)+1.4D0*(1.0D0-BET1)*(1.0D0-BET1)
         ELSE
   10       B=(1.0-DEXP(-TAU1))/TAU1
            DBDT=-1.D0/(TAU1*TAU1)+DEXP(-TAU1)/(TAU1*TAU1)+
     1                DEXP(-TAU1)/TAU1
            DB=BET1-B
            DT=DB/DBDT
            TAU=0.5D0*DT+TAU1
            TAU1=TAU
            IF(ABS(DT) .GT. .0005) GO TO 10
         ENDIF
      ENDIF
      RETURN
      END
C********************************************************
C***************End of TAUBETA***************************
C********************************************************
