      SUBROUTINE TERP(XXX,IFLAG,RVAL)
C
C   If IFLAG = 0, subroutine fits cubic spline to log of level
C                 population versus radius for all levels.
C   If IFLAG = 1, subroutine interpolates spline fits to derive
C                 level population for JLO and JUP at radius RVAL
C                 and calculates source function (SOUR).
C
C
      INCLUDE 'rad_size.h'
      INCLUDE 'radiat.h'
C
      INCLUDE 'mic_radsup.h'
      INCLUDE 'mic_tau.h'
C
      INTEGER IL,IFLAG,IP
      DOUBLE PRECISION XXX(MAXLEV,MAXMOD)
      REAL DUM(MAXMOD),S2(MAXMOD),SPOP(MAXLEV,MAXMOD),XT(5),YT(5),XD
      REAL popvals(MAXLEV,MAXMOD),epsln
      REAL RVAL,STIMCOR
      SAVE SPOP, popvals
C
C  Fit splines to level populations and store results in
C  array SPOP
C
      IF(IFLAG.GT.0) GO TO 105
      DO 100 IL=1,NLEV
         DO 20 IP=1,NPTS
            XD=XXX(IL,IP)
            IF(XD.LT.1.0E-16) XD=1.0E-16
            DUM(IP)=ALOG(XD)
   20    CONTINUE
         epsln = 1.0e-6
         CALL SPLNC(NPTS,RPT,DUM,epsln,S2)
         DO 30 IP=1,NPTS
	    popvals(il,ip) = dum(ip)
            SPOP(IL,IP)=S2(IP)
   30    CONTINUE
  100 CONTINUE
      RETURN
C
  105 XT(1)=RVAL
      IF(XT(1).GT.RPT(NPTS)) XT(1)=RPT(NPTS)
      IF(XT(1).LT.RPT(1))    XT(1) = RPT(1)
      DO 150 IP=1,NPTS
         DUM(IP)=popvals(jlo,ip)
         S2(IP)=SPOP(JLO,IP)
  150 CONTINUE
      CALL SPLN(NPTS,1,RPT,DUM,XT,YT,S2)
      XLO=EXP(YT(1))
      DO 200 IP=1,NPTS
         DUM(IP)=popvals(jup,ip)
         S2(IP)=SPOP(JUP,IP)
  200 CONTINUE
      CALL SPLN(NPTS,1,RPT,DUM,XT,YT,S2)
      XUP=EXP(YT(1))
      STIMCOR=XLO*DEGEN(JUP)/(XUP*DEGEN(JLO)) - 1.0
      IF(ABS(STIMCOR).GT.1.0E-10) then
          SOUR=2.0E+18*AH*(FREQ(JUP,JLO)**3)/(AC*AC*STIMCOR)
      ELSE
	  SOUR = 0.0
      ENDIF
      RETURN
      END
C************************************************************************
C********************* END OF TERP **************************************
C************************************************************************
